unit Forms.MainUnit;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.TMSFNCTypes, FMX.TMSFNCUtils, FMX.TMSFNCGraphics, FMX.TMSFNCGraphicsTypes,
  FMX.TMSFNCPageControl, FMX.TMSFNCRibbon, FMX.TMSFNCTabSet, FMX.TMSFNCHTMLText,
  FMX.TMSFNCToolBar, FMX.TMSFNCCustomControl, FMX.TMSFNCCustomComponent,
  FMX.TMSFNCBitmapContainer, FMX.Menus, FMX.ListBox, FMX.Controls.Presentation,
  FMX.Edit, FMX.TMSFNCCustomPicker, FMX.TMSFNCComboBox, FMX.TMSFNCTrackBar,
  FMX.TMSFNCSpinEdit, FMX.TMSFNCStrokeKindPicker, FMX.StdCtrls, FMX.Colors,
  FMX.TMSFNCColorPicker, FMX.TMSFNCCustomSelector, FMX.TMSFNCFillKindSelector,
  FMX.TMSFNCFontSizePicker, FMX.TMSFNCFontNamePicker, FMX.TMSFNCBitmapPicker;

type
  TMainForm = class(TTMSFNCRibbonForm)
    MyRibbon: TTMSFNCRibbon;
    TMSFNCRibbon1QAT: TTMSFNCRibbonQAT;
    TMSFNCRibbon1Caption: TTMSFNCRibbonCaption;
    TMSFNCRibbon1BottomContainer: TTMSFNCRibbonBottomContainer;
    TMSFNCRibbon1Icon: TTMSFNCRibbonIcon;
    TMSFNCRibbon1SystemMenu: TTMSFNCRibbonSystemMenu;
    TMSFNCRibbon1SystemMenuHelpButton: TTMSFNCRibbonSystemMenuToolBarButton;
    TMSFNCRibbon1SystemMenuMaximizeButton: TTMSFNCRibbonSystemMenuToolBarButton;
    TMSFNCRibbon1SystemMenuMinimizeButton: TTMSFNCRibbonSystemMenuToolBarButton;
    TMSFNCRibbon1SystemMenuCloseButton: TTMSFNCRibbonSystemMenuToolBarButton;
    TMSFNCRibbon1Wrapper: TTMSFNCRibbonToolBarWrapper;
    TMSFNCRibbon1PageControl: TTMSFNCRibbonPageControl;
    TMSFNCRibbon1PageControlFileButton: TTMSFNCRibbonFileButton;
    TMSFNCRibbon1PageControlContainer: TTMSFNCRibbonContainer;
    RibbonPageControlEdit: TTMSFNCRibbonPageControlContainer;
    RibbonToolBarFiles: TTMSFNCRibbonToolBar;
    ToolBarButtonCreateFile: TTMSFNCRibbonDefaultToolBarButton;
    ToolBarButtonOpenFile: TTMSFNCRibbonDefaultToolBarButton;
    PageControlSynoptics: TTMSFNCPageControl;
    DefaultToolBarButtonClose: TTMSFNCRibbonDefaultToolBarButton;
    OpenDialog1: TOpenDialog;
    ToolBarButtonSave: TTMSFNCRibbonDefaultToolBarButton;
    ToolBarButtonSaveAs: TTMSFNCRibbonDefaultToolBarButton;
    BitmapContainerIcons: TTMSFNCBitmapContainer;
    RibbonToolBarPanAndZoom: TTMSFNCRibbonToolBar;
    ToolBarButtonPan: TTMSFNCRibbonDefaultToolBarButton;
    ControlButtonClosePage: TTMSFNCRibbonSystemMenuToolBarButton;
    ToolBarButtonOrigin: TTMSFNCRibbonDefaultToolBarButton;
    ToolBarButtonZoomIn: TTMSFNCRibbonDefaultToolBarButton;
    ToolBarButtonZoomOut: TTMSFNCRibbonDefaultToolBarButton;
    RibbonToolBarGrid: TTMSFNCRibbonToolBar;
    ToolBarButtonGrid: TTMSFNCRibbonDefaultToolBarButton;
    ToolBarButtonSnap: TTMSFNCRibbonDefaultToolBarButton;
    PopupMenu1: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    ComboBoxGridSize: TTMSFNCComboBox;
    ComboBoxSnapSize: TTMSFNCComboBox;
    RibbonToolBarStrokeSettings: TTMSFNCRibbonToolBar;
    PanelStrokeSettings: TPanel;
    TMSFNCStrokeKindPicker1: TTMSFNCStrokeKindPicker;
    SpLineThickness: TTMSFNCSpinEdit;
    ColorPickerStroke: TTMSFNCColorPicker;
    RibbonToolBarFillSettings: TTMSFNCRibbonToolBar;
    PanelFillSettings: TPanel;
    ColorPickerFill: TTMSFNCColorPicker;
    TMSFNCBitmapPicker1: TTMSFNCBitmapPicker;
    RibbonToolBarFontSettings: TTMSFNCRibbonToolBar;
    PanelFontSettings: TPanel;
    FontNamePicker: TTMSFNCFontNamePicker;
    FontSizePicker: TTMSFNCFontSizePicker;
    ColorPickerFont: TTMSFNCColorPicker;
    RibbonToolbarTools: TTMSFNCRibbonToolBar;
    TMSFNCRibbonDefaultToolBarButton1: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton2: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton3: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton4: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton5: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton6: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton7: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton8: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton9: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbonDefaultToolBarButton10: TTMSFNCRibbonDefaultToolBarButton;
    TMSFNCRibbon1PageControlPage1: TTMSFNCRibbonPageControlContainer;
    procedure ToolBarButtonCreateFileClick(Sender: TObject);
    procedure ToolBarButtonOpenFileClick(Sender: TObject);
    procedure PageControlSynopticsChangePage(Sender: TObject;
      APreviousPageIndex, ACurrentPageIndex: Integer);
    procedure ToolBarButtonPanClick(Sender: TObject);
    procedure ToolBarButtonGridClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ToolBarButtonOriginClick(Sender: TObject);
    procedure ControlButtonClosePageClick(Sender: TObject);
    procedure ToolBarButtonSnapClick(Sender: TObject);
    procedure ToolBarButtonZoomInClick(Sender: TObject);
    procedure ToolBarButtonZoomOutClick(Sender: TObject);
    procedure ComboBoxGridSizeItemSelected(Sender: TObject; AText: string;
      AItemIndex: Integer);
    procedure ComboBoxSnapSizeItemSelected(Sender: TObject; AText: string;
      AItemIndex: Integer);
  private
    { Dclarations prives }
    procedure ShowHideIcons;
  public
    { Dclarations publiques }
    procedure RefreshIcons;
  end;

var
  MainForm: TMainForm;

implementation

uses
  Forms.SynopticUnit;

{$R *.fmx}

procedure TMainForm.ComboBoxGridSizeItemSelected(Sender: TObject; AText: string;
  AItemIndex: Integer);
var
 i:integer;
begin
 case AItemIndex of
  0:i:=5;
  1:i:=10;
  2:i:=15;
  3:i:=20;
  4:i:=25;
  else i:=5;
 end;
 TSynopticForm(PageControlSynoptics.activePage.DataObject).SetGridSize(i);
end;

procedure TMainForm.ComboBoxSnapSizeItemSelected(Sender: TObject; AText: string;
  AItemIndex: Integer);
var
 i:integer;
begin
 case AItemIndex of
  0:i:=5;
  1:i:=10;
  2:i:=15;
  3:i:=20;
  4:i:=25;
  else i:=5;
 end;
 TSynopticForm(PageControlSynoptics.activePage.DataObject).SetSnapSize(i);

end;

procedure TMainForm.ControlButtonClosePageClick(Sender: TObject);
begin
  TSynopticForm(PageControlSynoptics.activePage.DataObject).Free;
  PageControlSynoptics.Pages.Delete(PageControlSynoptics.ActivePageIndex);
  ShowHideIcons;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  ShowHideIcons;
end;

procedure TMainForm.PageControlSynopticsChangePage(Sender: TObject;
  APreviousPageIndex, ACurrentPageIndex: Integer);
begin
 ShowHideIcons;
end;

procedure TMainForm.RefreshIcons;
begin
 if TSynopticForm(PageControlSynoptics.activePage.DataObject).DoPan then
   ToolBarButtonPan.Bitmaps[0].BitmapName:='Hand-active' else ToolBarButtonPan.Bitmaps[0].BitmapName:='Hand';
 if TSynopticForm(PageControlSynoptics.activePage.DataObject).ShowGrid then
   ToolBarButtonGrid.Bitmaps[0].BitmapName:='Grid-active' else ToolBarButtonGrid.Bitmaps[0].BitmapName:='Grid';
 if TSynopticForm(PageControlSynoptics.activePage.DataObject).DoSnap then
   ToolBarButtonSnap.Bitmaps[0].BitmapName:='Magnet-active' else ToolBarButtonSnap.Bitmaps[0].BitmapName:='Magnet';
end;

procedure TMainForm.ShowHideIcons;
var
 PageActive:Boolean;
begin
 PageActive:=PageControlSynoptics.ActivePage<>nil;

 ControlButtonClosePage.Visible:=PageActive;

 ToolBarButtonSave.Visible:=PageActive;
 ToolBarButtonSaveAs.Visible:=PageActive;

 RibbonToolBarPanAndZoom.Visible:=PageActive;
 RibbonToolBarGrid.Visible:=PageActive;
 RibbonToolbarTools.Visible:=PageActive;
 RibbonToolBarStrokeSettings.Visible:=PageActive;
 RibbonToolBarFillSettings.Visible:=PageActive;
 RibbonToolBarFontSettings.Visible:=PageActive;

 if PageActive then
 begin
  RefreshIcons;
 end;
end;

procedure TMainForm.ToolBarButtonCreateFileClick(Sender: TObject);
var
  MyForm:TSynopticForm;
  MyPage:TTMSFNCPageControlPage;
begin
  MyPage:=PageControlSynoptics.Pages.Add;
  MyPage.DisplayName:='[unnamed]';
  MyForm:=TSynopticForm.Create(self);
  MyForm.Synoptic.Width:=640;
  MyForm.Synoptic.Height:=480;
  MyForm.layoutMain.Parent:=MyPage.Container;
  MyPage.DataObject:=MyForm;
  PageControlSynoptics.ActivePage:=MyPage;
  ShowHideIcons;
end;

procedure TMainForm.ToolBarButtonGridClick(Sender: TObject);
begin
  TSynopticForm(PageControlSynoptics.activePage.DataObject).ShowGrid:=not TSynopticForm(PageControlSynoptics.ActivePage.DataObject).ShowGrid;
  refreshIcons;
end;

procedure TMainForm.ToolBarButtonOpenFileClick(Sender: TObject);
var
  MyForm:TSynopticForm;
  MyPage:TTMSFNCPageControlPage;
begin
  if OpenDialog1.Execute then
  begin
    MyPage:=PageControlSynoptics.Pages.Add;
    MyForm:=TSynopticForm.Create(self);
    MyForm.layoutMain.Parent:=MyPage.Container;
    MyPage.DataObject:=MyForm;
    MyForm.LoadSynopticFile(OpenDialog1.FileName);
    PageControlSynoptics.ActivePage:=MyPage;
    ShowHideIcons;
  end;
end;

procedure TMainForm.ToolBarButtonOriginClick(Sender: TObject);
begin
  TSynopticForm(PageControlSynoptics.activePage.DataObject).SetOrigin;
end;

procedure TMainForm.ToolBarButtonPanClick(Sender: TObject);
begin
  TSynopticForm(PageControlSynoptics.activePage.DataObject).DoPan:=not TSynopticForm(PageControlSynoptics.ActivePage.DataObject).DoPan;
  refreshIcons;
end;

procedure TMainForm.ToolBarButtonSnapClick(Sender: TObject);
begin
  TSynopticForm(PageControlSynoptics.activePage.DataObject).DoSnap:=not TSynopticForm(PageControlSynoptics.ActivePage.DataObject).DoSnap;
  refreshIcons;
end;

procedure TMainForm.ToolBarButtonZoomInClick(Sender: TObject);
begin
  TSynopticForm(PageControlSynoptics.activePage.DataObject).Zoom(0.2);
end;

procedure TMainForm.ToolBarButtonZoomOutClick(Sender: TObject);
begin
  TSynopticForm(PageControlSynoptics.activePage.DataObject).Zoom(-0.2);
end;

end.
